| Home | Libraries | People | FAQ | More

#### write (6 of 6 overloads)

Write a certain amount of data to a stream before returning.

    template<
        typename SyncWriteStream,
        typename Allocator,
        typename CompletionCondition>
    std::size_t write(
        SyncWriteStream & s,
        basic_streambuf< Allocator > & b,
        CompletionCondition completion_condition,
        boost::system::error_code & ec);

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied basic_streambuf has been written.
- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's write_some function.

###### Parameters

s

  The stream to which the data is to be written. The type must support the SyncWriteStream concept.

b

  The basic_streambuf object from which data will be written.

completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

      bool completion_condition(
        const boost::system::error_code& error, // Result of latest write_some
                                                // operation.

        std::size_t bytes_transferred           // Number of bytes transferred
                                                // so far.
      );

  A return value of true indicates that the write operation is complete. False indicates that further calls to the stream's write_some function are required.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes written. If an error occurs, returns the total number of bytes successfully transferred prior to the error.